const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const routeAdministrationService = require('./routeAdministration.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new routeAdministration
 * @param {Object} req.body - The routeAdministration data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created routeAdministration
 */
function create(req, res, next) {
    routeAdministrationService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all routeAdministrations
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of routeAdministrations
 */
function getAll(req, res, next) {
    routeAdministrationService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of routeAdministration objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of routeAdministration objects
 */
function option(req, res, next) {
    routeAdministrationService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of routeAdministrations matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of routeAdministrations
 */
function count(req, res, next) {
    routeAdministrationService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing routeAdministration
 * @param {number} req.params.id - The routeAdministration ID to be updated
 * @param {Object} req.body - The routeAdministration data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated routeAdministration
 */
function update(req, res, next) {
    routeAdministrationService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a routeAdministration
 * @param {number} req.params.id - The routeAdministration ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    routeAdministrationService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
